var UsersManager = {


	init : function($in){

		this.$elem = $('<table/>',{class:'users'}).appendTo($in);

	},

	hydrate : function(users){
		this.$elem
			.append($('<thead/>')
				.append($('<tr/>')
					.append($('<th/>',{colspan:2}))
					.append($('<th/>')
						.append($('<img/>',{src:'img/livre.png'})))
					.append($('<th/>')
						.append($('<img/>',{src:'img/franc.png'})))
					.append($('<th/>') 
						.append($('<img/>',{src:'img/francccfl.png'})))));
		this.$users = this.$elem.append($('<tbody/>'));
		for (var i = 0; i < users.length; i++) {
			if(users[i].active>=1){
				this.$users.append($('<tr/>',{id:i})
					.append($('<td/>').text(users[i].username))
					.append($('<td/>')
						.append($('<img/>',{src:'img/users/'+i+'.jpeg'})))
					.append($('<td/>',{class:"livre",draggable:true,ondragstart:"UsersManager.drag(event,$(this))",ondrop:"UsersManager.drop(event)",ondragover:"UsersManager.allowDrop(event)"}).text(users[i].livre))
					.append($('<td/>',{class:"franc",draggable:true,ondragstart:"UsersManager.drag(event,$(this))",ondrop:"UsersManager.drop(event)",ondragover:"UsersManager.allowDrop(event)"}).text(users[i].franc))
					.append($('<td/>',{class:"franccfl",draggable:true,ondragstart:"UsersManager.drag(event,$(this))",ondrop:"UsersManager.drop(event)",ondragover:"UsersManager.allowDrop(event)"}).text(users[i].franccfl)));
			}
		}
		this.listen();
	},

	drop : function(e){
	    e.preventDefault();
	    var currency = e.dataTransfer.getData("currency");
	    var amount = e.dataTransfer.getData("amount");
	    var user = $(e.target).parent().attr('id');
	    app.ask(9,function(data){

	    	if(data<=amount&&currency=='livre'){
	    		PlevenManager.livre -= data;
	    		app.users[user].livre += data;
	    	}else if(data<=amount&&currency=='franc'){
	    		PlevenManager.franc -= data;
	    		app.users[user].franc += data;
	    	}else if(data<=amount&&currency=='franccfl'&&YearManager.actual>=1942){
	    		PlevenManager.franccfl -= data;
	    		app.users[user].franccfl += data;
	    	}
	    	PlevenManager.update();
	    	UsersManager.update(user);
	    });
	},

	allowDrop : function(e){
		e.preventDefault();
	},

	drag : function(e,that){
		console.log(e);
		e.dataTransfer.setData("user", that.parent().attr('id'));
		e.dataTransfer.setData("currency", that.attr('class'));
		e.dataTransfer.setData("amount", app.users[that.parent().attr('id')][that.attr('class')]);
	},	

	update : function(id){
		$('tr#'+id).find('td.livre').text(app.displayInt(app.users[id].livre));
		$('tr#'+id).find('td.franc').text(app.displayInt(app.users[id].franc));
		$('tr#'+id).find('td.franccfl').text(app.displayInt(app.users[id].franccfl));
	},

	listen : function(){
		$('td.livre').each(function(){
			$(this).click(function(e){
				e.preventDefault();
				var that = $(this);
				var id = that.parent().attr('id');
				app.ask(3,function(add){
					if((app.users[id].livre+add)>=0){
						app.users[id].livre += add; 
						that.text(app.displayInt(app.users[id].livre));
					}
				});
			});
		});
		$('td.franc').each(function(){
			$(this).click(function(e){
				e.preventDefault();
				var that = $(this);
				var id = that.parent().attr('id');
				app.ask(3,function(add){
					if((app.users[id].franc+add)>=0){
						app.users[id].franc += add; 
						that.text(app.displayInt(app.users[id].franc));
					}
				});
			});
		});
		$('td.franccfl').each(function(){
			$(this).click(function(e){
				e.preventDefault();
				if(YearManager.actual>=1942){
					var that = $(this);
					var id = that.parent().attr('id');
					app.ask(3,function(add){
						if((app.users[id].franccfl+add)>=0){
							app.users[id].franccfl += add; 
							that.text(app.displayInt(app.users[id].franccfl));
						}
					});
				}
			});
		});
	}

}