var app = {

	characters : ["Pierre Denis", "René Cassin", "Pierre Dac", "Passy", "Maurice Dejean", "André Diethelm","René Pleven","André Postel Vinay"],

	init : function($body){
		this.$body = $body;
		PlevenManager.init(this.$body);
		BankManager.init(this.$body);
		PrintingManager.init(this.$body);
		YearManager.init(this.$body);
		UsersManager.init(this.$body);
		FccflManager.init(this.$body);
		RecruitmentManager.init(this.$body);
		// OperationsManager.init(this.$body);
		GameManager.init(this.$body);
		this.$shadow = $('<div/>',{class:'game-shadow'}).appendTo(this.$body).hide();
		this.users = []
		for (var i = 0; i < this.characters.length; i++) {
			this.users.push(new User(this.characters[i]))
		}
		$('div.game-shadow').css({bottom:-1*($(document).outerHeight(true)-$(window).outerHeight(true))+"px"});
	},

	displayInt : function(x){
  		return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
	},

	ask : function(type,cb){
		this.$shadow.show();
		switch(type){
			case 0:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'recruts',placeholder:"Combien de nouvelles recrues ?"}))
				.append($('<input/>',{type:'submit',value:'Ajouter'}).click(function(e){
					e.preventDefault();
					if($('input[name=recruts]').val()!=""){
						cb(parseInt($('input[name=recruts]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 1:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'print',placeholder:"Combien de £ ?"}))
				.append($('<input/>',{type:'submit',value:'Envoyer'}).click(function(e){
					e.preventDefault();
					if($('input[name=print]').val()!=""){
						cb(parseInt($('input[name=print]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 2:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'amount',placeholder:"Combien ?"}))
				.append($('<select/>',{name:'currency'})
					.append($('<option/>',{value:"F"}).text("Franc / Franc CCFL"))
					.append($('<option/>',{value:"L"}).text("£")))
				.append($('<input/>',{type:'submit',value:'Convertir'}).click(function(e){
					e.preventDefault();
					if($('input[name=amount]').val()!=""){
						cb(parseInt($('input[name=amount]').val()),$('select[name=currency]').val());
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 3:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'add',placeholder:"Quelle somme ajouter ?"}))
				.append($('<input/>',{type:'submit',value:'Ajouter'}).click(function(e){
					e.preventDefault();
					if($('input[name=add]').val()!=""){
						cb(parseInt($('input[name=add]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 4:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'add',placeholder:"Combien de Francs CCFL ?"}))
				.append($('<input/>',{type:'submit',value:'Envoyer'}).click(function(e){
					e.preventDefault();
					if($('input[name=add]').val()!=""){
						cb(parseInt($('input[name=add]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 5:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'add',placeholder:"Combien de Francs ?"}))
				.append($('<input/>',{type:'submit',value:'Envoyer'}).click(function(e){
					e.preventDefault();
					if($('input[name=add]').val()!=""){
						cb(parseInt($('input[name=add]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 6:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'amount',placeholder:"Combien de Livres ?"}))
				.append($('<input/>',{type:'submit',value:'Imprimer'}).click(function(e){
					e.preventDefault();
					if($('input[name=amount]').val()!=""){
						cb(parseInt($('input[name=amount]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 7:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'amount',placeholder:"Quel montant ?"}))
				.append($('<input/>',{type:'submit',value:'Changer'}).click(function(e){
					e.preventDefault();
					if($('input[name=amount]').val()!=""){
						cb(parseInt($('input[name=amount]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 8:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'amount',placeholder:"Quel montant ?"}))
				.append($('<input/>',{type:'submit',value:'Déposer'}).click(function(e){
					e.preventDefault();
					if($('input[name=amount]').val()!=""){
						cb(parseInt($('input[name=amount]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
			case 9:
				this.$shadow
				.append($('<div/>',{class:'ask-numeric'})
				.append($('<input/>',{type:'number',name:'amount',placeholder:"Quel montant ?"}))
				.append($('<input/>',{type:'submit',value:'Retirer'}).click(function(e){
					e.preventDefault();
					if($('input[name=amount]').val()!=""){
						cb(parseInt($('input[name=amount]').val()));
					}
					app.$shadow.empty().hide();
				})));
				break;
		}
	}

}